std::map(3)

NAME
std::map -

SYNOPSIS

Detailed Description

  template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >> class std::map< _Key, _Tp, _Compare, _Alloc >
Meets the requirements of a container, a reversible container, and an associative container (using unique keys). For a map<Key,T> the key_type is Key, the mapped_type is T, and the value_type is std::pair<const Key,T>.

Maps support bidirectional iterators.

Definition at line 92 of file stl_map.h.

  Public Types
typedef _Alloc allocator_type
typedef _Rep_type::const_iterator const_iterator
typedef _Pair_alloc_type::const_pointer const_pointer
typedef _Pair_alloc_type::const_reference const_reference
typedef _Rep_type::const_reverse_iterator const_reverse_iterator
typedef _Rep_type::difference_type difference_type
typedef _Rep_type::iterator iterator
typedef _Compare key_compare
typedef _Key key_type
typedef _Tp mapped_type
typedef _Pair_alloc_type::pointer pointer
typedef _Pair_alloc_type::reference reference
typedef _Rep_type::reverse_iterator reverse_iterator
typedef _Rep_type::size_type size_type
typedef std::pair< const _Key, _Tp > value_type

  Public Member Functions
const mapped_type & at (const key_type &__k) const
mapped_type & at (const key_type &__k)
const_iterator begin () const
iterator begin ()
void clear ()
size_type count (const key_type &__x) const
bool empty () const
const_iterator end () const
iterator end ()
std::pair< const_iterator, const_iterator > equal_range (const key_type &__x) const
std::pair< iterator, iterator > equal_range (const key_type &__x)
void erase (iterator __first, iterator __last)
size_type erase (const key_type &__x)
void erase (iterator __position)
const_iterator find (const key_type &__x) const
iterator find (const key_type &__x)
allocator_type get_allocator () const
template<typename _InputIterator> void insert (_InputIterator __first, _InputIterator __last)
iterator insert (iterator position, const value_type &__x)
std::pair< iterator, bool > insert (const value_type &__x)
key_compare key_comp () const
const_iterator lower_bound (const key_type &__x) const
iterator lower_bound (const key_type &__x)
template<typename _InputIterator> map (_InputIterator __first, _InputIterator __last, const _Compare &__comp, const allocator_type &__a=allocator_type())
template<typename _InputIterator> map (_InputIterator __first, _InputIterator __last)
map (const map &__x)
map (const _Compare &__comp, const allocator_type &__a=allocator_type())
map ()
size_type max_size () const
map & operator= (const map &__x)
mapped_type & operator[] (const key_type &__k)
const_reverse_iterator rbegin () const
reverse_iterator rbegin ()
const_reverse_iterator rend () const
reverse_iterator rend ()
size_type size () const
void swap (map &__x)
const_iterator upper_bound (const key_type &__x) const
iterator upper_bound (const key_type &__x)
value_compare value_comp () const

  Friends
template<typename _K1, typename _T1, typename _C1, typename _A1> bool operator< (const map< _K1, _T1, _C1, _A1 > &, const map< _K1, _T1, _C1, _A1 > &)
template<typename _K1, typename _T1, typename _C1, typename _A1> bool operator== (const map< _K1, _T1, _C1, _A1 > &, const map< _K1, _T1, _C1, _A1 > &)

  Classes
class value_compare

Constructor & Destructor Documentation

  map () [inline]

Default constructor creates no elements.

Definition at line 156 of file stl_map.h.

  map (const _Compare & __comp, const allocator_type & __a = allocator_type()) [inline, explicit]

Default constructor creates no elements.

Definition at line 164 of file stl_map.h.

  map (const map< _Key, _Tp, _Compare, _Alloc > & __x) [inline]

Map copy constructor.

Parameters:
    x A map of identical element and allocator types.

The newly-created map uses a copy of the allocation object used by x.

Definition at line 174 of file stl_map.h.

  map (_InputIterator __first, _InputIterator __last) [inline]

Builds a map from a range.

Parameters:
    first An input iterator.
    last An input iterator.

Create a map consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 187 of file stl_map.h.

  map (_InputIterator __first, _InputIterator __last, const _Compare & __comp, const allocator_type & __a = allocator_type()) [inline]

Builds a map from a range.

Parameters:
    first An input iterator.
    last An input iterator.
    comp A comparison functor.
    a An allocator object.

Create a map consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 203 of file stl_map.h.

Member Function Documentation

  mapped_type& at (const key_type & __k) [inline]

Access to map data.

Parameters:
    k The key for which data should be retrieved.

Returns:
    A reference to the data whose key is equivalent to k, if such a data is present in the map.

Exceptions:
    std::out_of_range If no such data is present.

Definition at line 362 of file stl_map.h.

References std::lower_bound().

  const_iterator begin () const [inline]

Returns a read-only (constant) iterator that points to the first pair in the map. Iteration is done in ascending order according to the keys.

Definition at line 252 of file stl_map.h.

  iterator begin () [inline]

Returns a read/write iterator that points to the first pair in the map. Iteration is done in ascending order according to the keys.

Definition at line 243 of file stl_map.h.

  void clear () [inline]

Erases all elements in a map. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 500 of file stl_map.h.

  size_type count (const key_type & __x) const [inline]

Finds the number of elements with given key.

Parameters:
    x Key of (key, value) pairs to be located.

Returns:
    Number of elements with specified key.

This function only makes sense for multimaps; for map the result will either be 0 (not present) or 1 (present).

Definition at line 560 of file stl_map.h.

  bool empty () const [inline]

Returns true if the map is empty. (Thus begin() would equal end().)

Definition at line 313 of file stl_map.h.

  const_iterator end () const [inline]

Returns a read-only (constant) iterator that points one past the last pair in the map. Iteration is done in ascending order according to the keys.

Definition at line 269 of file stl_map.h.

  iterator end () [inline]

Returns a read/write iterator that points one past the last pair in the map. Iteration is done in ascending order according to the keys.

Definition at line 260 of file stl_map.h.

  std::pair<const_iterator, const_iterator> equal_range (const key_type & __x) const [inline]

Finds a subsequence matching given key.

Parameters:
    x Key of (key, value) pairs to be located.

Returns:
    Pair of read-only (constant) iterators that possibly points to the subsequence matching given key.

This function is equivalent to

    std::make_pair(c.lower_bound(val),
                   c.upper_bound(val))

 (but is faster than making the calls separately).

This function probably only makes sense for multimaps.

Definition at line 648 of file stl_map.h.

  std::pair<iterator, iterator> equal_range (const key_type & __x) [inline]

Finds a subsequence matching given key.

Parameters:
    x Key of (key, value) pairs to be located.

Returns:
    Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

    std::make_pair(c.lower_bound(val),
                   c.upper_bound(val))

 (but is faster than making the calls separately).

This function probably only makes sense for multimaps.

Definition at line 629 of file stl_map.h.

  void erase (iterator __first, iterator __last) [inline]

Erases a [first,last) range of elements from a map.

Parameters:
    first Iterator pointing to the start of the range to be erased.
    last Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 475 of file stl_map.h.

  size_type erase (const key_type & __x) [inline]

Erases elements according to the provided key.

Parameters:
    x Key of element to be erased.

Returns:
    The number of elements erased.

This function erases all the elements located by the given key from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 460 of file stl_map.h.

  void erase (iterator __position) [inline]

Erases an element from a map.

Parameters:
    position An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a map. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 445 of file stl_map.h.

  const_iterator find (const key_type & __x) const [inline]

Tries to locate an element in a map.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Read-only (constant) iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns a constant iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 548 of file stl_map.h.

  iterator find (const key_type & __x) [inline]

Tries to locate an element in a map.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 533 of file stl_map.h.

  allocator_type get_allocator () const [inline]

Get a copy of the memory allocation object.

Definition at line 233 of file stl_map.h.

References _Rb_tree::get_allocator().

  void insert (_InputIterator __first, _InputIterator __last) [inline]

A template function that attemps to insert a range of elements.

Parameters:
    first Iterator pointing to the start of the range to be inserted.
    last Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 432 of file stl_map.h.

  iterator insert (iterator position, const value_type & __x) [inline]

Attempts to insert a std::pair into the map.

Parameters:
    position An iterator that serves as a hint as to where the pair should be inserted.
    x Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
    An iterator that points to the element with key of x (may or may not be the pair passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/23_containers/howto.html#4 for more on 'hinting'.

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 419 of file stl_map.h.

  std::pair<iterator,bool> insert (const value_type & __x) [inline]

Attempts to insert a std::pair into the map.

Parameters:
    x Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
    A pair, of which the first element is an iterator that points to the possibly inserted pair, and the second is a bool that is true if the pair was actually inserted.

This function attempts to insert a (key, value) pair into the map. A map relies on unique keys and thus a pair is only inserted if its first element (the key) is not already present in the map.

Insertion requires logarithmic time.

Definition at line 395 of file stl_map.h.

  key_compare key_comp () const [inline]

Returns the key comparison object out of which the map was constructed.

Definition at line 509 of file stl_map.h.

  const_iterator lower_bound (const key_type & __x) const [inline]

Finds the beginning of a subsequence matching given key.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Read-only (constant) iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 590 of file stl_map.h.

  iterator lower_bound (const key_type & __x) [inline]

Finds the beginning of a subsequence matching given key.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 575 of file stl_map.h.

  size_type max_size () const [inline]

Returns the maximum size of the map.

Definition at line 323 of file stl_map.h.

  map& operator= (const map< _Key, _Tp, _Compare, _Alloc > & __x) [inline]

Map assignment operator.

Parameters:
    x A map of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 225 of file stl_map.h.

References map::_M_t.

  mapped_type& operator[] (const key_type & __k) [inline]

Subscript ( [] ) access to map data.

Parameters:
    k The key for which data should be retrieved.

Returns:
    A reference to the data of the (key,data) pair.

Allows for easy lookup with the subscript ( [] ) operator. Returns data associated with the key specified in subscript. If the key does not exist, a pair with that key is created using default values, which is then returned.

Lookup requires logarithmic time.

Definition at line 340 of file stl_map.h.

References __glibcxx_function_requires, and std::lower_bound().

  const_reverse_iterator rbegin () const [inline]

Returns a read-only (constant) reverse iterator that points to the last pair in the map. Iteration is done in descending order according to the keys.

Definition at line 287 of file stl_map.h.

  reverse_iterator rbegin () [inline]

Returns a read/write reverse iterator that points to the last pair in the map. Iteration is done in descending order according to the keys.

Definition at line 278 of file stl_map.h.

  const_reverse_iterator rend () const [inline]

Returns a read-only (constant) reverse iterator that points to one before the first pair in the map. Iteration is done in descending order according to the keys.

Definition at line 305 of file stl_map.h.

  reverse_iterator rend () [inline]

Returns a read/write reverse iterator that points to one before the first pair in the map. Iteration is done in descending order according to the keys.

Definition at line 296 of file stl_map.h.

  size_type size () const [inline]

Returns the size of the map.

Definition at line 318 of file stl_map.h.

  void swap (map< _Key, _Tp, _Compare, _Alloc > & __x) [inline]

Swaps data with another map.

Parameters:
    x A map of the same element and allocator types.

This exchanges the elements between two maps in constant time. (It is only swapping a pointer, an integer, and an instance of the Compare type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(m1,m2) will feed to this function.

Definition at line 490 of file stl_map.h.

References map::_M_t.

Referenced by std::swap().

  const_iterator upper_bound (const key_type & __x) const [inline]

Finds the end of a subsequence matching given key.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Read-only (constant) iterator pointing to first iterator greater than key, or end().

Definition at line 610 of file stl_map.h.

  iterator upper_bound (const key_type & __x) [inline]

Finds the end of a subsequence matching given key.

Parameters:
    x Key of (key, value) pair to be located.

Returns:
    Iterator pointing to the first element greater than key, or end().

Definition at line 600 of file stl_map.h.

  value_compare value_comp () const [inline]

Returns a value comparison object, built from the key comparison object out of which the map was constructed.

Definition at line 517 of file stl_map.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.